#include <DS1307.h>
#include <Wire.h>
#include <Adafruit_GFX.h>   // Core graphics library
#include <RGBmatrixPanel.h> // Hardware-specific library
#include "Bitmap.h"
#include <SD.h>
#include <SPI.h>

File myFile;
DS1307 rtc(SDA, SCL);

#define CLK 52
#define LAT 53
#define OE  51
#define A   A0
#define B   A1
#define C   A2
#define D   A3 

const byte pinInterr = 2;
byte i, x, y, r, g, b, menu;

long antirebond = 15;
volatile unsigned long der_micros;
boolean etat;

RGBmatrixPanel matrix(A, B, C, D, CLK, LAT, OE, true, 64); // 32x64

void setup() {
  // Initialisation communication I2C
  Wire.begin();  
  // Initialise le module RTC
  rtc.begin();  
  // Initialise la matrice
  matrix.begin(); 
  Serial.begin(9600);
  matrix.swapBuffers(false);
  texte();
  chargement(); 
  ecrannoir();

  pinMode(pinInterr, INPUT_PULLUP);
  menu = 1;
  
  //Parametrer date et heure
 //rtc.setTime(12, 15, 00);
 //rtc.setDate(29, 3, 2020); //Mois Jour Année
}
/*
  void Increm()
  {
    if (menu > 2)
    {
      menu = 0;
      }
      else
      {
    menu = menu + 1;
    delay(1000);
    if ((long)micros()- der_micros >= antirebond *1000)
    {    
    stopInterr();
    der_micros = micros();
    } 
      }
  }
*/
 /* void stopInterr()
  {
    detachInterrupt(digitalPinToInterrupt(pinInterr));
    delay(500);
  }
*/
  void texte()
  {      
    matrix.setCursor(3, 8);   // 3 pixels du bord gauche et 8 du haut
    matrix.setTextSize(1);    // size 1 == 8 pixels high
    matrix.setTextColor(matrix.Color333(3,3,3));
    matrix.print("Chargement");  
    matrix.drawRect(0, 0, 64, 32, matrix.Color333(3, 3, 3));
    matrix.swapBuffers(false);
  }

  void ecrannoir()
  {
  matrix.fillScreen(0);
  matrix.swapBuffers(false);
  }

  void chargement()
  {
   x=3;
   y=20;
    
   matrix.setCursor(3, 8);
   matrix.setTextSize(1);
   matrix.setTextColor(matrix.Color333(2,2,2));
   matrix.print("Chargement");  
   matrix.drawRect(0, 0, 64, 32, matrix.Color333(2, 2, 2));
    
    for (i=0; i<58; i++) // progressbar
    {
      matrix.drawPixel(x, y, matrix.Color333(0,3,0));
      matrix.drawPixel(x, y+1, matrix.Color333(0,3,0));
      matrix.drawPixel(x, y+2, matrix.Color333(0,3,0));
      matrix.drawPixel(x, y+3, matrix.Color333(0,3,0));
      x++;
      matrix.swapBuffers(false);
      delay(10);
      } 
      
    matrix.swapBuffers(false);    
  }

  void principal()
  {
    long compteur=0;
    while (compteur != 500)
    {
    matrix.fillScreen(0);
    String heurecomplete = rtc.getTimeStr();
    String h = heurecomplete.substring(0,2);
    String m = heurecomplete.substring(3,5);
    String s = heurecomplete.substring(6,8);
    matrix.setCursor(2, 1);
    matrix.setTextSize(2);    
    matrix.setTextColor(matrix.Color333(0,255,1)); // here is changing color RGB
    matrix.print(h + ":" + m );
    matrix.setCursor(20, 17);
    matrix.print(s);
    matrix.swapBuffers(false); 
    compteur++;
    }
    compteur =0;
      /*if (h.toInt() != 0)
      {
      matrix.drawFastHLine(2, 15, h.toInt(), matrix.Color333(0, 0 ,2));
      }
    if (m.toInt() != 0)
      {  
      matrix.drawFastHLine(2, 16, m.toInt(), matrix.Color333(2, 2 ,2));
      }
    if (s.toInt() != 0)
      {
      matrix.drawFastHLine(2, 17, s.toInt(), matrix.Color333(2, 0 ,0));
      }
        
    matrix.setCursor(2, 22);
    matrix.setTextSize(2);
    matrix.setTextColor(matrix.Color333(0,1,4));
    matrix.print(rtc.getDateStr());*/
        while (compteur != 50)
    {
    matrix.fillScreen(0);
    matrix.setCursor(1, 1);
    matrix.setTextSize(2);    
    matrix.setTextColor(matrix.Color333(0,255,1));
    matrix.print(rtc.getDateStr());
    matrix.swapBuffers(false);
  compteur++;
    }
    
  }

  // Animation avec deux fonctions chord() et animation()
  void Chord(int r, float rot)
  {
  int nodes = 6;
  float x[nodes];
  float y[nodes];
  for (int i=0; i<nodes; i++)
  {
    float a = rot + (PI*2*i/nodes);
    x[i] = 31+3 + cos(a)*r;
    y[i] = 16 + sin(a)*r;
  }
  matrix.fillScreen(0);
  for (int i=0; i<(nodes-1); i++)
    for (int j=i+1; j<nodes; j++)
      matrix.writeLine(x[i],y[i], x[j],y[j], matrix.Color333(2, 0,0));  
  }

  void animation()
  {
    float rot;
    float rotationSpeed = PI/15;
    for (int r=1; r<44; r+=3) {
      Chord(r, rot+=rotationSpeed);
      delay(50);
      matrix.swapBuffers(false);
    }
    for (int r=1; r<44; r+=3) {
      Chord(44-r, rot-=rotationSpeed);
      delay(30);
      matrix.swapBuffers(false);
    }  
  }

  void feuartifice()      // Joli rendu mais bug certaines fois
  {     
  byte comp = random(1, 5);
  etat = false;
  byte xx[comp], yy[comp], ray[comp], rou[comp], ver[comp], ble[comp], yym[comp];
  matrix.fillScreen(0);
  matrix.swapBuffers(false);
  
  for (i=1; i<=comp; i++){
    xx[i]=random(4,60);
    yy[i]=random(5,26);
    ray[i]=random(0, 4);
    rou[i]=random(0,7);
    ver[i]=random(0,7);
    ble[i]=random(0,7);
    yym[i]=random(33,36);
  }
    
  if (comp<2){yym[2]=yy[2];yym[3]=yy[3];yym[4]=yy[4];}
  if (comp<3){yym[3]=yy[3];yym[4]=yy[4];}
  if (comp<4){yym[4]=yy[4];}
 
  do
  {
    matrix.fillScreen(0);

    if (comp>=1){
    matrix.writePixel(xx[1], yym[1], matrix.Color333(rou[1], ver[1], ble[1]));
    matrix.swapBuffers(false);
      if (yym[1]!= yy[1])
      {
      yym[1]--;
      matrix.fillScreen(0);
      }  
    } 
    
    if (comp>=2)
    {
    matrix.writePixel(xx[2], yym[2], matrix.Color333(rou[2], ver[2], ble[2]));
    matrix.swapBuffers(false);
      if (yym[2]!= yy[2]){
          yym[2]--;
          matrix.fillScreen(0);
          }
    }
    if (comp>=3)
    {    
    matrix.writePixel(xx[3], yym[3], matrix.Color333(rou[3], ver[3], ble[3]));
    matrix.swapBuffers(false);  
      if (yym[3]!= yy[3]){
          yym[3]--;
          matrix.fillScreen(0);
          }  
    }    
    if (comp==4)
    {   
    matrix.writePixel(xx[4], yym[4], matrix.Color333(rou[4], ver[4], ble[4]));
    matrix.swapBuffers(false);
      if (yym[4]!= yy[4]){
          yym[4]--; 
          matrix.fillScreen(0);
          }
    }       
    matrix.swapBuffers(false);
    delay(10);
    matrix.fillScreen(0);
    if ((yym[1] == yy[1]) && (yym[2]== yy[2]) && (yym[3]== yy[3]) && (yym[4]== yy[4])){etat = true;}
    }
  while (etat != true);
  
  matrix.drawCircle(xx[1], yy[1], 1, matrix.Color333(2, 2, 2));
  if (comp>=2){matrix.drawCircle(xx[2], yy[2], 1, matrix.Color333(2, 2, 2));}
  if (comp>=3){matrix.drawCircle(xx[3], yy[3], 1, matrix.Color333(2, 2, 2));}
  if (comp>=4){matrix.drawCircle(xx[4], yy[4], 1, matrix.Color333(2, 2, 2));}            
  matrix.swapBuffers(false);
  delay(60);
  matrix.fillScreen(0);
    
  for (int j=0; j < comp + random(6, 12); j++)
      {    
        matrix.drawCircle(xx[1], yy[1], ray[1], matrix.Color333(rou[1], ver[1], ble[1]));
        if (comp>=2){matrix.drawCircle(xx[2], yy[2], ray[2], matrix.Color333(rou[2], ver[2], ble[2]));}
        if (comp>=3){matrix.drawCircle(xx[3], yy[3], ray[3], matrix.Color333(rou[3], ver[3], ble[3]));}
        if (comp>=4){matrix.drawCircle(xx[4], yy[4], ray[4], matrix.Color333(rou[3], ver[4], ble[4]));}
        delay(60);
        ray[1]++;
        if (comp>=2){ray[2]++;}
        if (comp>=3){ray[3]++;}
        if (comp>=4){ray[4]++;}
        matrix.swapBuffers(false);
        matrix.fillScreen(0);
      } 
  matrix.fillScreen(0); 
  matrix.swapBuffers(false);        
  }

  void imagetest()
  {
    matrix.drawRGBBitmap(0, 0, test, 64, 32);
    matrix.swapBuffers(false);      
  }
  
void loop() 
{

  
  //attachInterrupt(digitalPinToInterrupt(pinInterr), Increm, FALLING); // Interrompt la sequence sur appui du bouton

  switch (menu)
  {
    case 1:
      principal();
      break;
    case 2:
      feuartifice();
      break;
    case 3:
      menu = 1;
      break;
   }
}
